<?php
/**
 * @brief		4.1.19 Beta 1 Upgrade Code
 *
 * @copyright	(c) 2001 - 2016 Invision Power Services, Inc.
 *
 * @package		IPS Community Suite
 * @subpackage	Pages
 * @since		15 Feb 2017
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\cms\setup\upg_101090;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * 4.1.19 Beta 1 Upgrade Code
 */
class _Upgrade
{
	/**
	 * ...
	 *
	 * @return	array	If returns TRUE, upgrader will proceed to next step. If it returns any other value, it will set this as the value of the 'extra' GET parameter and rerun this step (useful for loops)
	 */
	public function step1()
	{
		foreach( \IPS\Db::i()->select( '*', 'cms_databases' ) as $db )
		{
			\IPS\Db::i()->update( 'cms_custom_database_' . $db['database_id'], array( 'record_edit_time' => 0 ), array( 'record_edit_time=record_saved AND record_edit_member_id=?', 0 ) );
		}

		return TRUE;
	}
}