<?php

$request = \IPS\Request::i();
$board_url = \IPS\Settings::i()->base_url;
$app_forum_name = \IPS\Settings::i()->board_name;
$tapatalk_dir = isset(\IPS\Settings::i()->tapatalk_plugindir) ? \IPS\Settings::i()->tapatalk_plugindir : 'mobiquo';
$api_key = \IPS\Settings::i()->tapatalk_apikey;
$page_type = \IPS\Dispatcher\Front::i()->controller;
require_once 'helper.php';
$TT_AllowSmartbanner = true;
switch($page_type)
{
    case 'index':
    {
        $page_type='home';
        break;
    }
    case 'forums':
    {
        $page_type='forum';
        $TT_forum_id = $request->__get('id');
        break;
    }
    case 'topic':
    {
        try
        {
            $page_type='topic';
            $topic = \IPS\forums\Topic::load( $request->__get('id'));
            $twc_title = $topic->__get('title');
            $firstPost = \IPS\forums\Topic\Post::load( $topic->topic_firstpost );
            if(isset($firstPost))
            {
                $short_content = TT_process_short_content($firstPost->__get('post'));
                $twc_description = $short_content;
                $TT_forum_id = $topic->__get('forum_id');
            }
        }
        catch(Exception $ex)
        {}
        break;
    }
    default:
    {
        $page_type='other';
        break;
    }
}

$TT_bannerControlData = isset(\IPS\Settings::i()->tapatalk_banner_data) ? unserialize(\IPS\Settings::i()->tapatalk_banner_data) : false;
$TT_expireTime = isset(\IPS\Settings::i()->tapatalk_banner_expire) ? \IPS\Settings::i()->tapatalk_banner_expire : 0;

require_once(\IPS\ROOT_PATH . "/" . $tapatalk_dir . "/mbqFrame/3rdLib/classTTConnection.php");
$TT_connection = new \classTTConnection();

$app_banner_enable =  \IPS\Settings::i()->tapatalk_mobilesmartbanner;
$google_indexing_enabled = \IPS\Settings::i()->tapatalk_mobilegoogle;
$facebook_indexing_enabled = \IPS\Settings::i()->tapatalk_mobilefacebook;
$twitter_indexing_enabled = \IPS\Settings::i()->tapatalk_mobiletwitter;
$TT_connection->calcSwitchOptions($TT_bannerControlData, $app_banner_enable, $google_indexing_enabled, $facebook_indexing_enabled, $twitter_indexing_enabled);

if(isset($TT_bannerControlData['byo_info']) && !empty($TT_bannerControlData['byo_info']))
{
    $app_rebranding_id = $TT_bannerControlData['byo_info']['app_rebranding_id'];
    $app_url_scheme = $TT_bannerControlData['byo_info']['app_url_scheme'];
    $app_icon_url = $TT_bannerControlData['byo_info']['app_icon_url'];
    $app_name = $TT_bannerControlData['byo_info']['app_name'];
    $app_alert_status = $TT_bannerControlData['byo_info']['app_alert_status'];
    $app_alert_message = $TT_bannerControlData['byo_info']['app_alert_message'];

    $app_android_id = $TT_bannerControlData['byo_info']['app_android_id'];
    $app_android_description = $TT_bannerControlData['byo_info']['app_android_description'];
    $app_banner_message_android = $TT_bannerControlData['byo_info']['app_banner_message_android'];
    $app_banner_message_android = preg_replace('/\r\n/','<br>',$app_banner_message_android);

    $app_ios_id = $TT_bannerControlData['byo_info']['app_ios_id'];
    $app_ios_description = $TT_bannerControlData['byo_info']['app_ios_description'];
    $app_banner_message_ios = $TT_bannerControlData['byo_info']['app_banner_message_ios'];
    $app_banner_message_ios = preg_replace('/\r\n/','<br>',$app_banner_message_ios);
}

$twc_site = isset($TT_bannerControlData['twitter_account']) && !empty($TT_bannerControlData['twitter_account']) ? $TT_bannerControlData['twitter_account'] : "tapatalk";

include_once(\IPS\ROOT_PATH . "/" . $tapatalk_dir . "/helper.php");
if(isset($TT_forum_id) && function_exists('mobiquo_hide_forum_array'))
{
    $TT_hiddenForums = mobiquo_hide_forum_array();
    if(is_array($TT_hiddenForums)&& in_array($TT_forum_id,$TT_hiddenForums))
    {
        $TT_AllowSmartbanner = false;
    }
}

$app_location = get_tapatalk_location($request,$page_type);      
$distpatcher = \IPS\Dispatcher\Front::i()->dispatcherController;

if($TT_AllowSmartbanner)
{
    include_once(\IPS\ROOT_PATH . "/" . $tapatalk_dir . "/smartbanner/head.inc.php");
}
