<?php
/**
 * @brief		bimForumStats Widget
 * @author		<a href='http://www.invisionpower.com'>Invision Power Services, Inc.</a>
 * @copyright	(c) 2001 - SVN_YYYY Invision Power Services, Inc.
 * @license		http://www.invisionpower.com/legal/standards/
 * @package		IPS Social Suite
 * @subpackage	bimforumstats
 * @since		01 Aug 2015
 * @version		SVN_VERSION_NUMBER
 */

namespace IPS\plugins\bim40forumsstats\widgets;

/* To prevent PHP errors (extending class does not exist) revealing path */
if ( !defined( '\IPS\SUITE_UNIQUE_KEY' ) )
{
	header( ( isset( $_SERVER['SERVER_PROTOCOL'] ) ? $_SERVER['SERVER_PROTOCOL'] : 'HTTP/1.0' ) . ' 403 Forbidden' );
	exit;
}

/**
 * bimForumStats Widget
 */
class _bimForumStats extends \IPS\Widget
{
	/**
	 * @brief	Widget Key
	 */
	public $key = 'bimForumStats';
	
	/**
	 * @brief	App
	 */
	public $app = '';
		
	/**
	 * @brief	Plugin
	 */
	public $plugin = '2';
	
	/**
	 * Initialise this widget
	 *
	 * @return void
	 */ 
	public function init()
	{
		$this->template( array( \IPS\Theme::i()->getTemplate( 'plugins', 'core', 'global' ), 'bim_forumStats' ) );
		parent::init();
	}
	

	/**
	 * Render a widget
	 *
	 * @return	string
	 */
	public function render()
	{
		$where = array();
		
		$where[] = array( 'forums_forums.password IS NULL AND forums_forums.can_view_others=1' );
		
		if ( !empty( \IPS\Settings::i()->bim_fstats_newpost_cats ) )
		{
			$where[] = array( 'forum_id IN (' . implode( ",", \IPS\Settings::i()->bim_fstats_newpost_cats ) . ')' );
		}
		
		$limit = \IPS\Settings::i()->bim_fstats_items > 0 ? \IPS\Settings::i()->bim_fstats_items : 10;
		
		$newposts = \IPS\forums\Topic::getItemsWithPermission( $where, "last_post DESC", $limit, 'read' );
		$newtopics = \IPS\forums\Topic::getItemsWithPermission( $where, "tid DESC", $limit, 'read' );		
		
		if ( count( $newposts ) && count( $newtopics ) )
		{
			return $this->output( $newposts, $newtopics );
		}
		else
		{
			return '';
		}

	}
}